﻿#include "hmg.ch"

#define SM_CXSIZEFRAME         32

Function Main()
LOCAL cMsg
LOCAL cHbpFile := "Demo2.hbp"
LOCAL cFileMain := "Demo1.prg"
LOCAL cHbpPath := "D:\Fontes\HMG\Testes\MsgBox"
LOCAL aItems := {"Create new project "+Chr(34)+cFileNoExt(cHbpFile)+Chr(34)+" with existed -> "+cFileMain, ;
                 "Create new project "+Chr(34)+cFileNoExt(cHbpFile)+Chr(34)+" with new -> "+cFileNoExt(cHbpFile)+".prg", ;
				 "Create new project "+Chr(34)+cFileNoExt(cHbpFile)+Chr(34)+" with new -> Main.prg"}

// Change language for captions buttons
InitMessages( "EN" )
*InitMessages( "ES" )
*InitMessages( "PT" )

cMsg := OptionBox("Project "+Chr(34)+cHbpFile+Chr(34)+" not found","At "+cHbpPath,aItems, 2)

MsgDebug( cMsg )
Return Nil

Function OptionBox( cTitle1, cTitle2, aOptions, nDefault )
LOCAL nFontSize := 9
LOCAL nLenTit := TitleLen(cTitle1)
LOCAL nLenItens := ItemsMaxLen(aOptions,nFontSize)
LOCAL nWidth, nMaxLen, nColButtons, nBorder, cCaption1, cCaption2
LOCAL cParentWindowName, nRet

DEFAULT nDefault := 1
DEFAULT cTitle2 := ""

cCaption1 := _HMG_SYSDATA [ 331 ] [6]
cCaption2 := _HMG_SYSDATA [ 331 ] [7]
nWidth := Max( nLenItens, nLenTit)
If nWidth < 210
   nWidth := 210
Endif
nBorder := GetSystemMetrics( SM_CXSIZEFRAME )
nColButtons := ( (nWidth+50) - (210+nBorder) ) / 2

SET WINDOW MAIN OFF
DEFINE WINDOW OPTIONBOX AT 0,0 WIDTH nWidth+50 HEIGHT 170 + ( 30 * ( LEN(aOptions) - 2 ) );
    TITLE cTitle1 MODAL NOSIZE NOSYSMENU

    DEFINE FRAME Frame_1
       ROW       04
       COL       10
       WIDTH     nWidth+26
       HEIGHT    86 + ( 30 * ( LEN(aOptions) - 2 ) )
       CAPTION   cTitle2
	   FONTCOLOR BLUE
    END FRAME

    DEFINE RADIOGROUP Radio_1
       ROW      30
       COL      26
       WIDTH    nWidth
       HEIGHT   108 + ( 30 * ( LEN(aOptions) - 2 ) )
       OPTIONS  aOptions
       VALUE    nDefault
       ONCHANGE {|| nRet := THIS.VALUE }
	   FONTNAME "Arial"
       FONTSIZE nFontSize
    END RADIOGROUP

    DEFINE BUTTON OK
       ROW      110 + ( 30 * ( LEN(aOptions) - 2 ) )
       COL      nColButtons + 0
       CAPTION  cCaption1
       ACTION   OptionBox_Ok()
	   FONTNAME "Arial"
       FONTSIZE nFontSize
    END BUTTON

    DEFINE BUTTON CANCEL
       ROW     110 + ( 30 * ( LEN(aOptions) - 2 ) )
       COL     nColButtons + 110
       CAPTION cCaption2
       ACTION  OptionBox_Cancel(@nRet)
	   FONTNAME "Arial"
       FONTSIZE nFontSize
    END BUTTON
	
    ON KEY ESCAPE ACTION OptionBox_Cancel(@nRet)

END WINDOW

IF ASCAN( _HMG_SYSDATA[69], "A" ) > 0 .AND. _HMG_MainWindowFirst==.T.    //    ASCAN( _HMG_SYSDATA[69], "A" ) > 0 if MAIN window is defined
  cParentWindowName:=ThisWindow.Name
  CENTER WINDOW OPTIONBOX IN &cParentWindowName
ELSE
   CENTER WINDOW OPTIONBOX DESKTOP  
ENDIF

ACTIVATE WINDOW OPTIONBOX
Return nRet

Function TitleLen(cTitle)
LOCAL nRet

nRet := GetMinWidth( 0, cTitle ) - 70
Return nRet

Function ItemsMaxLen(aItems,nFontSize)
LOCAL nMxLn := 0
FontHandle := 0 // Based on Size 9 - GetControlFontHandle( "Radio_1", "OPTIONBOX" )

AEVAL( aItems, { | cItem | nMxLn := Max( nMxLn, GetTextWidth( NIL, cItem, FontHandle ) ) } )
Return nMxLn

Function OptionBox_Ok()
nRet := OPTIONBOX.RADIO_1.VALUE
ThisWindow.RELEASE
SET WINDOW MAIN ON
Return Nil

Function OptionBox_Cancel(nRet)
ThisWindow.RELEASE
SET WINDOW MAIN ON
Return Nil

#pragma BEGINDUMP

#include "SET_COMPILE_HMG_UNICODE.ch"
#include "HMG_UNICODE.h"

#include <windows.h>
#include <commctrl.h>
#include <wingdi.h>
#include <winuser.h>

#include "hbapi.h"
#include "hbvm.h"

HB_FUNC( GETMINWIDTH )
  {
    HWND hwnd = (HWND) hb_parnl( 1 );
    HDC hDC = GetDC( hwnd );
    int xMin;
  
    if (hDC)
    {
      xMin = LOWORD( GetTabbedTextExtent( hDC, HMG_parc( 2 ), hb_parclen( 2 ), 0, NULL ) );
      ReleaseDC( hwnd, hDC );
      hb_retni( xMin );
    }
  }
#pragma ENDDUMP